/**
 *
 */
package de.intevation.gnv.geobackend.base;

import java.io.Serializable;
import java.util.Date;


/**
 * Interface which provides the Methods for Accessing
 * the Data of an ResultEntry
 * @author Tim Englich <tim.englich@intevation.de>
 *
 */
public interface Result extends Serializable{

    /**
     * Returns the ResultDescriptor which provides the
     * ResultMetadatse
     * @return the ResultDescriptor
     */
    public ResultDescriptor getResultDescriptor();

    /**
     * Returns the Columnvalue as a String
     * @param columnName the Name of the column
     * @return the Columnvalue as a String
     */
    public String getString(String columnName);

    /**
     * Returns the Columnvalue as a String
     * @param column the Position of the Column that should be returned.
     * @return the Columnvalue as a String
     */
    public String getString(int column);

    /**
     * Returns the Columnvalue as a Date
     * @param columnName the Name of the column
     * @return the Columnvalue as a Date
     */
    public Date getDate(String columnName);

    /**
     * Returns the Columnvalue as a Date
     * @param column the Position of the Column that should be returned.
     * @return the Columnvalue as a Date
     */
    public Date getDate(int column);

    /**
     * Returns the Columnvalue as a Integer
     * @param columnName the Name of the column
     * @return the Columnvalue as a Integer
     */
    public Integer getInteger(String columnName);

    /**
     * Returns the Columnvalue as a Integer
     * @param column the Position of the Column that should be returned.
     * @return the Columnvalue as a Integer
     */
    public Integer getInteger(int column);

    /**
     * Returns the Columnvalue as a Float
     * @param columnName the Name of the column
     * @return the Columnvalue as a Float
     */
    public Float getFloat(String columnName);

    /**
     * Returns the Columnvalue as a Float
     * @param column the Position of the Column that should be returned.
     * @return the Columnvalue as a Float
     */
    public Float getFloat(int column);

    /**
     * Returns the Columnvalue as a Double
     * @param columnName the Name of the column
     * @return the Columnvalue as a Double
     */
    public Double getDouble(String columnName);

    /**
     * Returns the Columnvalue as a Double
     * @param column the Position of the Column that should be returned.
     * @return the Columnvalue as a Double
     */
    public Double getDouble(int column);

    /**
     * Returns the Columnvalue as a Object
     * @param columnName the Name of the column
     * @return the Columnvalue as a Object
     */
    public Object getObject(String columnName);

    /**
     * Returns the Columnvalue as a Object
     * @param column the Position of the Column that should be returned.
     * @return the Columnvalue as a Object
     */
    public Object getObject(int column);

    /**
     * Adds an new Coumnvalue to the Result.
     * @param columnName the Name of the Column
     * @param value the Value of the Column
     */
    public void addColumnValue(int column, Object value);
}
